package com.example.joner.socialman;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.BottomNavigationView;
import android.support.v7.app.AppCompatActivity;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

import com.facebook.login.LoginManager;
import com.twitter.sdk.android.core.TwitterCore;

/**
 * An activity to access various account settings
 */
public class AccountSettings extends AppCompatActivity {

    private Button logout;
    private Button manageNetworks;
    private Button historyButton;
    private Button friendsButton;

    private BottomNavigationView.OnNavigationItemSelectedListener mOnNavigationItemSelectedListener = new BottomNavigationView.OnNavigationItemSelectedListener() {
        @Override
        public boolean onNavigationItemSelected(@NonNull MenuItem menuItem) {
            switch (menuItem.getItemId()) {
                case R.id.navHome:
                    Intent i = new Intent(AccountSettings.this, MainActivity.class);
                    startActivity(i);
                    return true;
                case R.id.createPost:
                    i = new Intent(AccountSettings.this, CreatePost.class);
                    startActivity(i);
                    return true;
                case R.id.account:
                    return true;
            }
            return false;
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_account_settings);

        BottomNavigationView navigation = (BottomNavigationView) findViewById(R.id.navigation);
        navigation.setOnNavigationItemSelectedListener(mOnNavigationItemSelectedListener);
        navigation.setSelectedItemId(R.id.account);

        logout = findViewById(R.id.logout);
        manageNetworks = findViewById(R.id.manageNetworks);
        historyButton = findViewById(R.id.historyButton);
        friendsButton = findViewById(R.id.friendsButton);

        logout.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                Variables.getInstance().setManualLogout(true);

                SharedPreferences.Editor editor = getSharedPreferences("manual logout", MODE_PRIVATE).edit();
                editor.putString("logout", "true");
                editor.apply();

                Variables.getInstance().getWebSocketClient().close();
                Variables.getInstance().getChats().clear();

                Variables.getInstance().setLoggedInFacebook(false);
                Variables.getInstance().setLoggedInTwitter(false);
                Variables.getInstance().setLoggedInReddit(false);
                Variables.getInstance().reset();
                Intent i = new Intent(AccountSettings.this, WelcomeActivity.class);
                startActivity(i);
            }
        });

        manageNetworks.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                Intent i = new Intent(AccountSettings.this, ManageNetworks.class);
                startActivity(i);
            }
        });

        historyButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                Intent i = new Intent(AccountSettings.this, History.class);
                startActivity(i);
            }
        });

        friendsButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View view) {
                Intent i = new Intent(AccountSettings.this, Friends.class);
                startActivity(i);
            }
        });
    }
}
